
/******************************************************************************
* MODULE     : matrix_test.cc
* DESCRIPTION: Test matrices
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "integer.hpp"
#include "dense_matrix.hpp"
using namespace mml;

int
main () {
  matrix<integer> M(1,10,10);
  cout << "M =\n" << M << "\n";
  matrix<integer> N(3,10,10);
  cout << "N =\n" << N << "\n";
  cout << "N + M =\n" << M+N << "\n";
  N -= M;
  cout << "N -= M -> \n" << N << "\n";
  N *= 3;
  cout << "N *= 3 -> \n" << N << "\n";
  N += N;
  cout << "N += N -> \n" << N << "\n";
  N /= 6;
  cout << "N /= 6 -> \n" << N << "\n";
  N -= M;
  cout << "(N-=M) == M -> " << (N==M) << "\n \n";
  integer* o = new integer[200];
  integer* t=o;
  for(nat i = 0; i < 200; i++) {
    *t = integer(i);
    t++;
  }
  matrix<integer> O(o,20,10);
  cout << "O =\n" << O << "\n";
  cout << "transpose(O) =\n" << transpose(O) << "\n";
  cout << "submatrix(O,0,10,0,10) =\n" << submatrix(O,0,10,0,10) << "\n";
  cout << "N*transpose(O) =\n" << N * transpose(O) << "\n";
  cout << "O...=\n" << iterate(O) << "\n";
  inline_rows_add(M, 0, integer(2) , 3, integer(3));
  cout << "2*row(0,M) += 3*row(3,M) -> \n" << M << "\n";
  inline_swap_row(M,0,6);
  cout << "row(0,M) <-> row(6,M) -> \n" << M << "\n";
  return 0;
}
